# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    This module copyright (C) 2013 Savoir-faire Linux
#    (<http://www.savoirfairelinux.com>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from openerp.osv import fields, orm


class res_institutions(orm.Model):
    _description = 'Institutions'
    _name = 'res.institution'
    _order = 'sequence asc'
    _columns = {
        'name': fields.char('Name', size=256, required=True, select=True,
                            help='Name of institution.'),
        'sequence': fields.integer('Sequence', help="Used to order the institutions"),
        'institutionfunction_ids': fields.one2many('res.institution.functions', 'institution_id', 'Functions'),
    }
    _sql_constraints = [('institution_name_unique', 'unique(name)', 'Name already exists')]


class res_institutions_functions(orm.Model):
    _description = 'Institutions functions'
    _name = 'res.institution.functions'
    _order = 'sequence asc'
    _columns = {
        'functions_id': fields.many2one('functions', 'Functions', required='True'),
        'sequence': fields.integer('Sequence', help="Used to order"),
        'institution_id': fields.many2one('res.institution', 'Institutions'),
    }

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
